// cl GStrings.cpp /O1 /Os /GS- /c
//GStrings.cpp
#define   UNICODE
#define   _UNICODE
#include  "windows.h"
#include  "stdlib.h"
#include  "stdio.h"
#include  "tchar.h"
//#include  <math.h>
#include  "string.h"
#include  "GStrings.h"


String::String()
{
 lpBuffer=new TCHAR[MINIMUM_ALLOCATION];
 lpBuffer[0]=_T('\0');
 this->iCapacity=MINIMUM_ALLOCATION-1;
 this->iLen=0;
}


String& String::operator=(const TCHAR ch)                  // Assigns a TCHAR to a String
{
 this->lpBuffer[0]=ch, this->lpBuffer[1]=_T('\0');
 this->iLen=1;
 return *this;
}


String& String::operator=(const TCHAR* pStr)               // Assigns a TCHAR* to a String
{
 size_t iNewLen=_tcslen(pStr);
 if(iNewLen>this->iCapacity)
 {
    delete [] this->lpBuffer;
    size_t iNewSize=(iNewLen*EXPANSION_FACTOR/16+1)*16;
    this->lpBuffer=new TCHAR[iNewSize];
    this->iCapacity=iNewSize-1;
 }
 _tcscpy(this->lpBuffer,pStr);
 this->iLen=iNewLen;

 return *this;
}


String& String::operator=(const String& strAnother)        // Assigns another String to a String
{
 if(this==&strAnother)
    return *this;
 if(strAnother.iLen>this->iCapacity)
 {
    delete [] this->lpBuffer;
    SIZE_T iNewSize=(strAnother.iLen*EXPANSION_FACTOR/16+1)*16;
    this->lpBuffer=new TCHAR[iNewSize];
    this->iCapacity=iNewSize-1;
 }
 _tcscpy(this->lpBuffer,strAnother.lpBuffer);
 this->iLen=strAnother.iLen;

 return *this;
}


bool String::operator==(const TCHAR* pStr)                 // Compares Two Strings For Equality
{
 if(_tcscmp(this->lpStr(),pStr)==0)
    return true;
 else
    return false;
}


int String::ParseCount(const TCHAR c)                      //returns one more than # of
{                                                          //delimiters so it accurately
 int iCtr=0;                                               //reflects # of strings delimited
 TCHAR* p;                                                 //by delimiter.

 p=this->lpBuffer;
 while(*p)
 {
  if(*p==c)
     iCtr++;
  p++;
 }

 return ++iCtr;
}


void String::Parse(String* pStr, TCHAR delimiter)
{
 unsigned int i=0;
 TCHAR* pBuffer=0;
 TCHAR* c;
 TCHAR* p;

 pBuffer=new TCHAR[this->iLen+1];
 if(pBuffer)
 {
    pBuffer[0]=0, p=pBuffer;
    c=this->lpBuffer;
    while(*c)
    {
       if(*c==delimiter)
       {
          pStr[i]=pBuffer,  p=pBuffer;
          i++,              pBuffer[0]=0;
       }
       else
       {
          *p=*c,  p++;
          *p=0;
       }
       c++;
    }
    pStr[i]=pBuffer;
    delete [] pBuffer;
 }
}


void String::LTrim()
{
 size_t iCt=0;

 for(size_t i=0; i<this->iLen; i++)
 {
     if(this->lpBuffer[i]==32 || this->lpBuffer[i]==9)
        iCt++;
     else
        break;
 }
 if(iCt)
 {
    for(size_t i=iCt; i<=this->iLen; i++)
        this->lpBuffer[i-iCt]=this->lpBuffer[i];
 }
 this->iLen=this->iLen-iCt;
}


int String::iVal()
{
 return _ttoi(this->lpBuffer);  //_ttoi
}


SIZE_T String::Len(void)
{
 return this->iLen;
}


TCHAR* String::lpStr()
{
 return lpBuffer;
}


String::~String()   //String Destructor
{
 delete [] lpBuffer;
 lpBuffer=0;
}
