//Grid.h
#ifndef     GRID_H_INCLUDED
#define     GRID_H_INCLUDED
#include    "Interfaces.h"
#define     MAX_CONNECTIONS  4
#define     dwIdx(r,c) ((r-1)*pGridData->iCols+(c-1))
extern long g_lObjs;
extern long g_lLocks;

class FHGrid : public IGrid, public IConnectionPointContainer, public IConnectionPoint
{
 public:
 FHGrid();            //Constructor
 virtual ~FHGrid();   //Destructor

 //Iunknown Functions
 virtual HRESULT STDMETHODCALLTYPE QueryInterface(const IID& iid, void** ppv);
 virtual ULONG   STDMETHODCALLTYPE AddRef();
 virtual ULONG   STDMETHODCALLTYPE Release();

 //IGrid Interface Methods/Functions
 virtual HRESULT STDMETHODCALLTYPE CreateGrid(HWND, BSTR, int, int, int, int, int, int, int, COLORREF, COLORREF, BSTR, int, int);
 virtual HRESULT STDMETHODCALLTYPE SetRowCount(int, int);
 virtual HRESULT STDMETHODCALLTYPE GetRowCount(int*);
 virtual HRESULT STDMETHODCALLTYPE SetData(int, int, BSTR);
 virtual HRESULT STDMETHODCALLTYPE GetData(int, int, BSTR*);
 virtual HRESULT STDMETHODCALLTYPE FlushData(void);
 virtual HRESULT STDMETHODCALLTYPE Refresh(void);
 virtual HRESULT STDMETHODCALLTYPE GetVisibleRows(int*);
 virtual HRESULT STDMETHODCALLTYPE GethGrid(HWND*);
 virtual HRESULT STDMETHODCALLTYPE GethCell(int, int, HWND*);
 virtual HRESULT STDMETHODCALLTYPE GethComboBox(int, HWND*);
 virtual HRESULT STDMETHODCALLTYPE SetCellAttributes(int, int, COLORREF, COLORREF);
 virtual HRESULT STDMETHODCALLTYPE DeleteRow(int);

 //IConnectionPointContainer Interface Methods/Functions
 virtual HRESULT STDMETHODCALLTYPE EnumConnectionPoints(IEnumConnectionPoints** ppEnum);            //not implemented
 virtual HRESULT STDMETHODCALLTYPE FindConnectionPoint(REFIID riid, IConnectionPoint** ppCP);

 // IConnectionPoint
 virtual HRESULT STDMETHODCALLTYPE GetConnectionInterface(IID* pIID);                               //not implemented
 virtual HRESULT STDMETHODCALLTYPE GetConnectionPointContainer(IConnectionPointContainer** ppCPC);  //not implemented
 virtual HRESULT STDMETHODCALLTYPE Advise(IUnknown* pUnknown, DWORD* pdwCookie);
 virtual HRESULT STDMETHODCALLTYPE Unadvise(DWORD dwCookie);
 virtual HRESULT STDMETHODCALLTYPE EnumConnections(IEnumConnections** ppEnum);                      //not implemented

 public:
 HWND          hWndCtrl;
 IGridEvents** pISink;
 long          m_lRef;
};


class GridClassFactory : public IClassFactory
{
 public:
 GridClassFactory();
 virtual ~GridClassFactory();

 public:
 //IUnknown
 virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID, void**);
 virtual ULONG   STDMETHODCALLTYPE AddRef();
 virtual ULONG   STDMETHODCALLTYPE Release();

 //IclassFactory
 virtual HRESULT STDMETHODCALLTYPE CreateInstance(LPUNKNOWN, REFIID, void**);
 virtual HRESULT STDMETHODCALLTYPE LockServer(BOOL);

 protected:
 long  m_lRef;
};


struct GridData
{
 int         iCtrlId;
 HWND        hParent;
 HWND        hGrid;
 HWND        hBase;
 HWND        hPane;
 HWND        hCtrlInCell;
 int         cx;
 int         cy;
 HWND        hHeader;
 int         iCols;
 int         iRows;
 int         iVisibleRows;
 int         iRowHeight;
 int         iPaneHeight;
 int         iEditedCellRow;
 int         iEditedRow;
 int         iEditedCol;
 FHGrid*     pComObj;
 DWORD*      pColWidths;
 DWORD*      pCellCtrlTypes;
 HWND*       pCellHandles;
 TCHAR**     pGridMemory;
 COLORREF*   pTextColor;
 HBRUSH*     pBackColor;
 COLORREF*   pCreatedColors;
 HBRUSH*     pCreatedBrushes;
 HWND*       pVButtons;
 HWND*       pCtrlHdls;
 COLORREF    iSelectionBackColor;
 COLORREF    iSelectionTextColor;
 int         blnRowSelected;
 int         iSelectedRow;
 int         iFontSize;
 int         iFontWeight;
 HFONT       hFont;
 TCHAR       szFontName[28];
};

void Initialize();
#endif
//End Grid.h


