//IFunctions.h
#ifndef INTERFACES_H_INCLUDED
#define INTERFACES_H_INCLUDED
const CLSID CLSID_FHGrid           =                    {0x30000000, 0x0000, 0x0000, {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}            };
const IID   IID_IFHGrid            =                    {0x30000000, 0x0000, 0x0000, {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01}            };
const IID   IID_IFHGridEvents      =                    {0x30000000, 0x0000, 0x0000, {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02}            };
const IID   LIBID_FHGrid           =                    {0x30000000, 0x0000, 0x0000, {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03}            };

interface IGrid : IUnknown
{
 virtual HRESULT STDMETHODCALLTYPE CreateGrid           (HWND, BSTR, int, int, int, int, int, int, int, COLORREF, COLORREF, BSTR, int, int) = 0;
 virtual HRESULT STDMETHODCALLTYPE SetRowCount          (int, int                                                                         ) = 0;
 virtual HRESULT STDMETHODCALLTYPE GetRowCount          (int*                                                                             ) = 0;
 virtual HRESULT STDMETHODCALLTYPE SetData              (int, int, BSTR                                                                   ) = 0;
 virtual HRESULT STDMETHODCALLTYPE GetData              (int, int, BSTR*                                                                  ) = 0;
 virtual HRESULT STDMETHODCALLTYPE FlushData            (void                                                                             ) = 0;
 virtual HRESULT STDMETHODCALLTYPE Refresh              (void                                                                             ) = 0;
 virtual HRESULT STDMETHODCALLTYPE GetVisibleRows       (int *iVisibleRows                                                                ) = 0;
 virtual HRESULT STDMETHODCALLTYPE GethGrid             (HWND*                                                                            ) = 0;
 virtual HRESULT STDMETHODCALLTYPE GethCell             (int, int, HWND*                                                                  ) = 0;
 virtual HRESULT STDMETHODCALLTYPE GethComboBox         (int, HWND*                                                                       ) = 0;
 virtual HRESULT STDMETHODCALLTYPE SetCellAttributes    (int, int, COLORREF, COLORREF                                                     ) = 0;
 virtual HRESULT STDMETHODCALLTYPE DeleteRow            (int                                                                              ) = 0;
};

interface IGridEvents : IUnknown
{
 virtual HRESULT STDMETHODCALLTYPE Grid_OnKeyPress      (int iKeyCode, int iKeyData, int iRow, int iCol, int* blnCancel                   ) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnKeyDown       (int KeyCode, int iKeyData, int iCellRow, int iGridRow, int iCol, int* blnCancel  ) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnLButtonDown   (int iCellRow, int iGridRow, int iCol                                             ) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnLButtonDblClk (int iCellRow, int iGridRow, int iCol                                             ) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnPaste         (int iCellRow, int iGridRow, int iCol                                             ) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnRowSelection  (int iRow, int iAction                                                            ) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnDelete        (int iRow                                                                         ) = 0;
};
#endif

