// cl Registry.cpp /O1 /Os /GS- /c
// Registry.cpp
#define   UNICODE
#define   _UNICODE
//#define   MYDEBUG
#include  <objbase.h>
#include  "string.h"
#include  "stdio.h"
#include  "tchar.h"
#include  "Registry.h"
const int CLSID_STRING_BUFFER_LENGTH = 39; //A CLSID Converted Needs 38 chars, i.e., {30000000-0000-0000-0000-000000000000}. The 39 number is for the terminating NULL.
#if defined MYDEBUG
extern FILE* fp;
#endif


BOOL SetKeyAndValue(const TCHAR* szKey, const TCHAR* szSubkey, const TCHAR* szValue)
{
 TCHAR szKeyBuf[1024];
 long lResult;
 HKEY hKey;

 #if defined MYDEBUG
 _ftprintf(fp,_T("    Entering SetKeyAndValue()\r\n"));
 _ftprintf(fp,_T("      szKey    = %s\r\n"),szKey);
 _ftprintf(fp,_T("      szSubkey = %s\r\n"),szSubkey);
 _ftprintf(fp,_T("      szValue  = %s\r\n"),szValue);
 #endif
 _tcscpy(szKeyBuf,szKey);
 if(szSubkey!=NULL)          // Add subkey name to buffer.
 {
     _tcscat(szKeyBuf, _T("\\"));
     _tcscat(szKeyBuf, szSubkey);
     #if defined MYDEBUG
     _ftprintf(fp,_T("      szKeyBuf = %s\r\n"),szKeyBuf);
     #endif
 }
 //Create and open key and subkey.
 lResult=RegCreateKeyEx(HKEY_CLASSES_ROOT,szKeyBuf,0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,NULL);
 if(lResult!=ERROR_SUCCESS)
    return FALSE ;
 if(szValue!=NULL)         //Set the Value.
    RegSetValueEx(hKey,NULL,0,REG_SZ,(BYTE*)szValue,(_tcslen(szValue)*sizeof(TCHAR))+sizeof(TCHAR));
 RegCloseKey(hKey);
 #if defined MYDEBUG
 _ftprintf(fp,_T("    Leaving SetKeyAndValue()\r\n"));
 #endif

 return TRUE;
}


void CLSIDToTChar(const CLSID& clsid, TCHAR* szCLSID, int iStrlen)    // Convert a CLSID to a TCHAR string.
{
 LPOLESTR wszCLSID=NULL;
 size_t pRet=0;
 HRESULT hr;

 #if defined MYDEBUG
 _ftprintf(fp,_T("    Entering CLSIDToTChar()\r\n"));
 #endif
 hr=StringFromCLSID(clsid,&wszCLSID);      // Get CLSID
 #if defined MYDEBUG
 _ftprintf(fp,_T("      iStrLen  = %d\r\n"),iStrlen);
 _ftprintf(fp,   _T("      wszCLSID = %s\r\n"),wszCLSID);
 #endif
 if(SUCCEEDED(hr))
 {
    #if defined UNICODE
        _tcscpy(szCLSID,wszCLSID);
        #if defined MYDEBUG
        _ftprintf(fp,_T("      szCLSID  = %s\r\n"),szCLSID);
        #endif
    #else
        //wcstombs_s(&pRet,szCLSID,iStrlen,wszCLSID,iStrlen); // Covert from wide characters to non-wide.
        WideCharToMultiByte(CP_ACP,0,wszCLSID,iStrLen,szCLSID,iStrLen,NULL,NULL);
        /*
        errno_t wcstombs_s
        (
          size_t *pReturnValue,      // [out] pReturnValue   The number of characters converted.
          char *mbstr,               // [out] mbstr          The address of a buffer for the resulting converted multibyte character string.
          size_t sizeInBytes,        // [in]sizeInBytes      The size in bytes of the mbstr buffer.
          const wchar_t *wcstr,      // [in] wcstr           Points to the wide character string to be converted.
          size_t count               // [in] count           The maximum number of bytes to be stored in the mbstr buffer, or _TRUNCATE.
        );
        
        int WideCharToMultiByte
        (
          UINT CodePage,         // code page
          DWORD dwFlags,         // performance and mapping flags
          LPCWSTR lpWideCharStr, // address of wide-character string
          int cchWideChar,       // number of characters in string
          LPSTR lpMultiByteStr,  // address of buffer for new string
          int cchMultiByte,      // size of buffer
          LPCSTR lpDefaultChar,  // address of default for unmappable characters
          LPBOOL lpUsedDefaultChar   // address of flag set when default char. used
         );
         
         int MultiByteToWideChar
         (
           UINT CodePage,         // code page
           DWORD dwFlags,         // character-type options
           LPCSTR lpMultiByteStr, // address of string to map
           int cchMultiByte,      // number of bytes in string
           LPWSTR lpWideCharStr,  // address of wide-character buffer
           int cchWideChar        // size of buffer
         );
         
         MultiByteToWideChar(CP_ACP,0,szBuffer,(int)strlen(szBuffer),szWide,511);
        */
        #if defined MYDEBUG
        _ftprintf(fp,  _T("      szCLSID  = %s\r\n"),szCLSID);
        _ftprintf(fp,  _T("      pRet     = %u\r\n"),pRet);
        #endif
    #endif
    CoTaskMemFree(wszCLSID);               // Free memory.
 }
 #if defined MYDEBUG
 _ftprintf(fp,_T("    Leaving CLSIDToTChar()\r\n"));
 #endif
}


LONG RecursiveDeleteKey(HKEY hKeyParent, const TCHAR* lpszKeyChild)       // Key to delete
{
 TCHAR szBuffer[256];
 DWORD dwSize=256 ;
 HKEY hKeyChild;
 FILETIME time;
 LONG lRes;

 lRes=RegOpenKeyEx(hKeyParent,lpszKeyChild,0,KEY_ALL_ACCESS,&hKeyChild); //Open the child.
 if(lRes!=ERROR_SUCCESS)
    return lRes;
 while(RegEnumKeyEx(hKeyChild,0,szBuffer,&dwSize,NULL,NULL,NULL,&time)==S_OK) //Enumerate all of the decendents of this child.
 {
  lRes=RecursiveDeleteKey(hKeyChild,szBuffer);  //Delete the decendents of this child.
  if(lRes!=ERROR_SUCCESS)
  {
     RegCloseKey(hKeyChild);  //Cleanup before exiting.
     return lRes;
  }
  dwSize=256;
 }
 RegCloseKey(hKeyChild);      // Close the child.

 return RegDeleteKey(hKeyParent,lpszKeyChild);  //Delete this child.
}


HRESULT RegisterServer(TCHAR* szModule, const CLSID& clsid, const TCHAR* szFriendlyName, const TCHAR* szVerIndProgID, const TCHAR* szProgID)
{
 TCHAR szCLSID[CLSID_STRING_BUFFER_LENGTH];   // GetModuleFileName(hModule,szModule,sizeof(szModule)/sizeof(TCHAR))
 TCHAR szKey[64];

 #if defined MYDEBUG
 _ftprintf(fp,_T("  Entering RegisterServer()\r\n"));
 _ftprintf(fp,_T("    szFriendlyName = %s\r\n"),szFriendlyName);
 _ftprintf(fp,_T("    szVerIndProgID = %s\r\n"),szVerIndProgID);
 _ftprintf(fp,_T("    szProgID       = %s\r\n"),szProgID);
 _ftprintf(fp,_T("    szModule       = %s\r\n"),szModule);
 #endif
 CLSIDToTChar(clsid, szCLSID, CLSID_STRING_BUFFER_LENGTH);            //Get server location &Convert the CLSID into a char.
 //_tcscpy_s(szKey, _T("CLSID\\"));                                   //Build the key CLSID\\{...}
 _tcscpy(szKey, _T("CLSID\\"));
 //_tcscat_s(szKey,szCLSID);
 _tcscat(szKey,szCLSID);
 #if defined MYDEBUG
 _ftprintf(fp,_T("    szCLSID        = %s\r\n"),szCLSID);
 _ftprintf(fp,_T("    szKey   = %s\r\n"),szCLSID);
 #endif
 SetKeyAndValue(szKey,NULL,szFriendlyName);                           //Add the CLSID to the registry.
 SetKeyAndValue(szKey, _T("InprocServer32"), szModule);               //Add the server filename subkey under the CLSID key.
 SetKeyAndValue(szKey, _T("ProgID"), szProgID);                       //Add the ProgID subkey under the CLSID key.
 SetKeyAndValue(szKey,_T("VersionIndependentProgID"),szVerIndProgID); //Add the version-independent ProgID subkey under CLSID key.
 SetKeyAndValue(szVerIndProgID, NULL, szFriendlyName);                //Add the version-independent ProgID subkey under HKEY_CLASSES_ROOT.
 SetKeyAndValue(szVerIndProgID, _T("CLSID"), szCLSID);
 SetKeyAndValue(szVerIndProgID, _T("CurVer"), szProgID);
 SetKeyAndValue(szProgID, NULL, szFriendlyName);                      //Add the versioned ProgID subkey under HKEY_CLASSES_ROOT.
 SetKeyAndValue(szProgID, _T("CLSID"), szCLSID);
 #if defined MYDEBUG
 _ftprintf(fp,_T("  Leaving RegisterServer()\r\n"));
 #endif

 return S_OK ;
}


HRESULT UnregisterServer(const CLSID& clsid, const TCHAR* szVerIndProgID, const TCHAR* szProgID)
{
 TCHAR szCLSID[CLSID_STRING_BUFFER_LENGTH];
 TCHAR szKey[64];
 LONG lResult;

 #if defined MYDEBUG
 _ftprintf(fp,  _T("  Entering UnregisterServer()\r\n"));
 #endif
 CLSIDToTChar(clsid, szCLSID,CLSID_STRING_BUFFER_LENGTH);                //Convert the CLSID into a char.
 //_tcscpy_s(szKey, _T("CLSID\\"));                                      //Build the key CLSID\\{...}
 _tcscpy(szKey,_T("CLSID\\"));
 //_tcscat_s(szKey, szCLSID) ;
 _tcscat(szKey,szCLSID);
 lResult=RecursiveDeleteKey(HKEY_CLASSES_ROOT, szKey);                   //Delete the CLSID Key - CLSID\{...}
 lResult=RecursiveDeleteKey(HKEY_CLASSES_ROOT, szVerIndProgID);          //Delete the version-independent ProgID Key.
 lResult=RecursiveDeleteKey(HKEY_CLASSES_ROOT, szProgID) ;               //Delete the ProgID key.
 #if defined MYDEBUG
 _ftprintf(fp,  _T("  Leaving UnregisterServer()\r\n"));
 #endif

 return S_OK ;
}
