// cl WinCode.cpp /O1 /Os /GS- /c
#define  UNICODE
#define  _UNICODE
#include <windows.h>
#include <commctrl.h>
#include <objbase.h>
#include <ocidl.h>
#include <olectl.h>
#include "memory.h"
#include "stdio.h"
#include "tchar.h"
#include "GStrings.h"
#include "Grid.h"
#include "WinCode.h"

#define SizX(x)  x * rxRatio
#define SizY(y)  y * ryRatio
//#define  MYDEBUG

#if defined MYDEBUG
extern   FILE* fp;
#endif

WNDPROC  fnEditWndProc;  // edit control subclass


long fnGridProc_OnCreate(lpWndEventArgs Wea)
{
 int iEndRectHt,iHalf,iRemainder,iDifference,iNewGridHt;
 int iCols=0,iFlds=0,iHdlCount=0,iCtr=0,iSize=0;
 CREATESTRUCT* pCreateStruct=NULL;
 GridData* pGridData1=NULL;
 GridData* pGridData2=NULL;
 String* strParseData;
 HANDLE hHeap=NULL;
 TCHAR szText[64];
 String strSetup;
 HDITEM hdrItem;
 DWORD dwStyle;
 HWND hCell;
 HDC hDC;
 RECT rc;

 #if defined MYDEBUG
 _ftprintf(fp,_T("  Entering fnGridProc_OnCreate()\r\n"));
 #endif
 pCreateStruct=(CREATESTRUCT*)Wea->lParam;
 Wea->hIns=pCreateStruct->hInstance;
 pGridData1=(GridData*)pCreateStruct->lpCreateParams;
 strSetup=(TCHAR*)pCreateStruct->lpszName;
 #if defined MYDEBUG
 _ftprintf(fp,_T("    Wea->hWnd                  = %u\r\n"),Wea->hWnd);
 _ftprintf(fp,_T("    pCreateStruct              = %u\r\n"),pCreateStruct);
 _ftprintf(fp,_T("    pGridData1                 = %u\r\n"),pGridData1);
 _ftprintf(fp,_T("    strSetup.lpStr()           = %s\r\n"),strSetup.lpStr());
 _ftprintf(fp,_T("    pCreateStruct->hwndParent  = %u\r\n"),pCreateStruct->hwndParent);
 _ftprintf(fp,_T("    pCreateStruct->x           = %d\r\n"),pCreateStruct->x);
 _ftprintf(fp,_T("    pCreateStruct->y           = %d\r\n"),pCreateStruct->y);
 _ftprintf(fp,_T("    pCreateStruct->cx          = %d\r\n"),pCreateStruct->cx);
 _ftprintf(fp,_T("    pCreateStruct->cy          = %d\r\n"),pCreateStruct->cy);
 _ftprintf(fp,_T("    pCreateStruct->hMenu       = %u\r\n"),pCreateStruct->hMenu);
 _ftprintf(fp,_T("    pGridData1->cx             = %d\r\n"),pGridData1->cx);
 _ftprintf(fp,_T("    pGridData1->iRows          = %d\r\n"),pGridData1->iRows);
 _ftprintf(fp,_T("    pGridData1->iCols          = %d\r\n"),pGridData1->iCols);
 _ftprintf(fp,_T("    pGridData1->iRowHeight     = %d\r\n"),pGridData1->iRowHeight);
 _ftprintf(fp,_T("    pGridData1->szFontName     = %s\r\n"),pGridData1->szFontName);
 _ftprintf(fp,_T("    pGridData1->iFontSize      = %d\r\n"),pGridData1->iFontSize);
 _ftprintf(fp,_T("    pGridData1->iFontWeight    = %d\r\n"),pGridData1->iFontWeight);
 #endif
 pGridData1->hGrid=Wea->hWnd;
 GetClientRect(Wea->hWnd,&rc);
 iCols=strSetup.ParseCount(_T(','));
 #if defined MYDEBUG
 _ftprintf(fp,_T("    rc.left                    = %d\r\n"),rc.left);
 _ftprintf(fp,_T("    rc.top                     = %d\r\n"),rc.top);
 _ftprintf(fp,_T("    rc.right                   = %d\r\n"),rc.right);
 _ftprintf(fp,_T("    rc.bottom                  = %d\r\n"),rc.bottom);
 _ftprintf(fp,_T("    iCols                      = %d\r\n"),iCols);
 #endif

 if(iCols!=pGridData1->iCols)
    return -1;
 hHeap=GetProcessHeap();
 if(!hHeap)
    return -1;
 pGridData2=(GridData*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,sizeof(GridData));
 if(!pGridData2)
    return -1;
 SetWindowLongPtr(Wea->hWnd,0,(LONG_PTR)pGridData2);
 pGridData1->blnRowSelected=FALSE;
 #if defined MYDEBUG
 _ftprintf(fp,_T("    pGridData2                 = %u\r\n"),pGridData2);
 #endif
 memcpy(pGridData2,pGridData1,sizeof(GridData));

 // DPI Handling
 double dpiX, dpiY;
 double rxRatio, ryRatio;
 hDC = GetDC(NULL);
 dpiX=GetDeviceCaps(hDC, LOGPIXELSX);
 dpiY=GetDeviceCaps(hDC, LOGPIXELSY);
 rxRatio=(dpiX/96);
 ryRatio=(dpiY/96);
 #ifdef MYDEBUG
 //_ftprintf(fp,_T("    dpiX                       = %6.2f\n"),dpiX);
 //_ftprintf(fp,_T("    dpiY                       = %6.2f\n"),dpiY);
 //_ftprintf(fp,_T("    rxRatio                    = %6.2f\n"),rxRatio);
 //_ftprintf(fp,_T("    ryRatio                    = %6.2f\n"),ryRatio);
 #endif
 // DPI Handling End

 // Now gonna try to create font ...
 #if defined MYDEBUG
 _ftprintf(fp,_T("\r\n    Now Gonna Try To Create Font...\r\n"));
 _ftprintf(fp,_T("    pGridData2->szFontName = %s\r\n"),pGridData2->szFontName);
 #endif
 if(pGridData2->szFontName)
 {
    pGridData2->hFont=CreateFont(-1*(pGridData2->iFontSize*dpiY)/72,0,0,0,pGridData2->iFontWeight,0,0,0,ANSI_CHARSET,0,0,DEFAULT_QUALITY,0,pGridData2->szFontName);
    #if defined MYDEBUG
    TEXTMETRIC tm;     // DPI Added!!!!!!
    HFONT hTmp=(HFONT)SelectObject(hDC,pGridData2->hFont);
    GetTextMetrics(hDC,&tm);  // DPI Added!!!!!!
    _ftprintf(fp,_T("    pGridData2->hFont = %u\r\n"),pGridData2->hFont);
    _ftprintf(fp,_T("    tm.tmHeight       = %d\r\n"),tm.tmHeight);
    _ftprintf(fp,_T("    tm.tmAveCharWidth = %d\r\n\r\n"),tm.tmAveCharWidth);
    SelectObject(hDC,hTmp);
    #endif
    ReleaseDC(Wea->hWnd,hDC);
 }
 else
    return -1;

 // Deal With Resizing Grid And Over-riding Client's Dimensions (a little) If Unsightly Extra
 // Space Exists Between Bottom Of Last Row And Top Of Horizontal Scroll Bar
 iNewGridHt=pCreateStruct->cy;
 iHalf=pGridData2->iRowHeight/2;
 iRemainder=rc.bottom % pGridData2->iRowHeight;
 #ifdef MYDEBUG
 _ftprintf(fp,_T("    iNewGridHt                 = %d\r\n"),iNewGridHt);
 _ftprintf(fp,_T("    pGridData2->iRowHeight     = %d\r\n"),pGridData2->iRowHeight);
 _ftprintf(fp,_T("    iHalf                      = %d\r\n"),iHalf);
 _ftprintf(fp,_T("    iRemainder                 = %d\r\n"),iRemainder);
 #endif
 if(iRemainder>=iHalf)
 {
    iDifference=pGridData2->iRowHeight-iRemainder;
    iEndRectHt=rc.bottom+(pGridData2->iRowHeight-iRemainder);
 }
 else
 {
    iDifference=-iRemainder;
    iEndRectHt=rc.bottom-iRemainder;
 }
 iNewGridHt=iNewGridHt+iDifference;
 #ifdef MYDEBUG
 _ftprintf(fp,_T("    iEndRectHt                 = %d\r\n"),iEndRectHt);
 _ftprintf(fp,_T("    iDifference                = %d\r\n"),iDifference);
 _ftprintf(fp,_T("    iNewGridHt                 = %d\r\n"),iNewGridHt);
 #endif
 pGridData2->iVisibleRows=(iEndRectHt-pGridData2->iRowHeight)/pGridData2->iRowHeight;
 if(pGridData2->iRows<pGridData2->iVisibleRows)
    pGridData2->iRows=pGridData2->iVisibleRows+1;
 pGridData2->iPaneHeight=(pGridData2->iVisibleRows+1)*pGridData2->iRowHeight;
 #if defined MYDEBUG
 _ftprintf(fp,_T("    pGridData2->hParent        = %u\r\n"),pGridData2->hParent);
 _ftprintf(fp,_T("    pGridData2->hGrid          = %u\r\n"),pGridData2->hGrid);
 _ftprintf(fp,_T("    pGridData2->iCtrlId        = %d\r\n"),pGridData2->iCtrlId);
 _ftprintf(fp,_T("    pGridData2->cx             = %u\r\n"),pGridData2->cx);
 _ftprintf(fp,_T("    pGridData2->cy             = %u\r\n"),pGridData2->cy);
 _ftprintf(fp,_T("    pGridData2->iRows          = %d\r\n"),pGridData2->iRows);
 _ftprintf(fp,_T("    pGridData2->iCols          = %d\r\n"),pGridData2->iCols);
 _ftprintf(fp,_T("    pGridData2->iRowHeight     = %d\r\n"),pGridData2->iRowHeight);
 _ftprintf(fp,_T("    pGridData2->szFontName     = %s\r\n"),pGridData2->szFontName);
 _ftprintf(fp,_T("    pGridData2->iFontSize      = %d\r\n"),pGridData2->iFontSize);
 _ftprintf(fp,_T("    pGridData2->iFontWeight    = %d\r\n"),pGridData2->iFontWeight);
 _ftprintf(fp,_T("    pGridData2->iVisibleRows   = %d\r\n"),pGridData2->iVisibleRows);
 _ftprintf(fp,_T("    pGridData2->iPaneHeight    = %d\r\n"),pGridData2->iPaneHeight);
 _ftprintf(fp,_T("    pGridData2->blnRowSelected = %d\r\n\r\n"),pGridData2->blnRowSelected);
 _ftprintf(fp,_T("    i         strParseData(i) \r\n"));
 _ftprintf(fp,_T("    ============================\r\n"));
 #endif
 strParseData=new String[iCols];
 strSetup.Parse(strParseData,_T(','));
 for(unsigned int i=0; i<iCols; i++)
 {
     strParseData[i].LTrim();
     #if defined MYDEBUG
     _ftprintf(fp,_T("    %d\t%s\r\n"),i,strParseData[i].lpStr());
     #endif
 }
 pGridData2->pColWidths=(DWORD*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,sizeof(DWORD)*(iCols+1));
 if(!pGridData2->pColWidths)
    goto CleanUp;
 #if defined MYDEBUG
 _ftprintf(fp,_T("\n    pGridData2->pColWidths    = %u\r\n"),pGridData2->pColWidths);
 #endif
 pGridData2->hBase=CreateWindowEx(0,_T("Base"),_T(""),WS_CHILD|WS_VISIBLE,0,0,0,0,Wea->hWnd,(HMENU)1499,Wea->hIns,0);
 pGridData2->hPane=CreateWindowEx(0,_T("Pane"),_T(""),WS_CHILD|WS_VISIBLE,0,0,0,0,pGridData2->hBase,(HMENU)ID_PANE,Wea->hIns,0);
 dwStyle=WS_CHILD | WS_BORDER | WS_VISIBLE | HDS_HOTTRACK | HDS_HORZ;
 pGridData2->hHeader=CreateWindowEx(0,WC_HEADER,_T(""),dwStyle,0,0,0,0,pGridData2->hPane,(HMENU)ID_HEADER,Wea->hIns,0);
 #if defined MYDEBUG
 _ftprintf(fp,_T("    pGridData2->hBase         = %u\r\n"),pGridData2->hBase);
 _ftprintf(fp,_T("    pGridData2->hPane         = %u\r\n"),pGridData2->hPane);
 _ftprintf(fp,_T("    pGridData2->hHeader       = %u\r\n"),pGridData2->hHeader);
 _ftprintf(fp,_T("    HDF_LEFT                  = %d\r\n"),HDF_LEFT);
 _ftprintf(fp,_T("    HDF_CENTER                = %d\r\n"),HDF_CENTER);
 _ftprintf(fp,_T("    HDF_RIGHT                 = %d\r\n\r\n"),HDF_RIGHT);
 #endif
 SetWindowLongPtr(pGridData2->hPane,0,(LONG_PTR)pGridData2);
 pGridData2->pCellCtrlTypes=(DWORD*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,iCols*sizeof(DWORD));    // no extra bytes allocated here, so its zero based
 if(!pGridData2->pCellCtrlTypes)
    goto CleanUp;
 pGridData2->pCtrlHdls=(HWND*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,iCols*sizeof(HWND*));          // no extra bytes allocated here either, so its zero based
 if(!pGridData2->pCtrlHdls)
    goto CleanUp;
 hdrItem.mask=HDI_FORMAT | HDI_WIDTH | HDI_TEXT;
 #if defined MYDEBUG
 _ftprintf(fp,_T("    i\tstrFieldData[0]\tpGridData2->pColWidths[i]\tstrFieldData[1]\tstrFieldData[2]\tstrFieldData[3]\tpPos[i]\t\tpGridData2->pCellCtrlTypes[i]\r\n"));
 _ftprintf(fp,_T("    ============================================================================================================================================\r\n"));
 #endif
 int* pPos=(int*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,iCols*sizeof(int));    // and no extra bytes allocated here
 if(!pPos)
    goto CleanUp;
 pGridData2->pColWidths[iCols]=0;
 for(unsigned int i=0; i<iCols; i++)
 {
     iFlds=strParseData[i].ParseCount(_T(':'));
     String* strFieldData=new String[iFlds];
     strParseData[i].Parse(strFieldData,_T(':'));
     pGridData2->pColWidths[i]=SizX((DWORD)strFieldData[0].iVal());
     pGridData2->pColWidths[iCols]=pGridData2->pColWidths[iCols]+pGridData2->pColWidths[i];
     hdrItem.cxy=pGridData2->pColWidths[i];
     _tcscpy(szText,strFieldData[1].lpStr());
     hdrItem.pszText=szText;
     hdrItem.cchTextMax=_tcslen(szText);
     hdrItem.fmt=0;
     if(strFieldData[2]==_T("<"))
        hdrItem.fmt=HDF_LEFT;
     else
     {
        if(strFieldData[2]==_T("^"))
           hdrItem.fmt=HDF_CENTER;
        else
           hdrItem.fmt=HDF_RIGHT;
     }
     hdrItem.fmt=hdrItem.fmt|HDF_STRING;
     Header_InsertItem(pGridData2->hHeader,i,&hdrItem);
     if(i)
        pPos[i]=pPos[i-1]+pGridData2->pColWidths[i-1];
     if(strFieldData[3]==_T("none"))
        pGridData2->pCellCtrlTypes[i]=0;
     else
     {
        if(strFieldData[3]==_T("edit"))
           pGridData2->pCellCtrlTypes[i]=1;
        else
        {
           if(strFieldData[3]==_T("combo"))
              pGridData2->pCellCtrlTypes[i]=2;
           if(strFieldData[3]==_T("check"))
              pGridData2->pCellCtrlTypes[i]=0;
        }
     }
     #if defined MYDEBUG
     _ftprintf
     (
      fp,
      _T("    %d\t%s\t\t%u\t\t\t\t%s\t%s\t\t%s\t\t%d\t\t%u\r\n"),
      i,strFieldData[0].lpStr(),pGridData2->pColWidths[i],strFieldData[1].lpStr(),strFieldData[2].lpStr(),strFieldData[3].lpStr(),pPos[i],pGridData2->pCellCtrlTypes[i]
     );
     #endif
     delete [] strFieldData;
 }
 #if defined MYDEBUG
 _ftprintf(fp,_T("\r\n"));
 _ftprintf(fp,_T("    iCols = %u\r\n\r\n"),iCols);
 _ftprintf(fp,_T("    i\tpGridData2->pColWidths[i]\r\n"));
 _ftprintf(fp,_T("    ================================\r\n"));
 for(unsigned int i=0; i<=iCols; i++)
     _ftprintf(fp,_T("    %u\t\t%u\r\n"),i,pGridData2->pColWidths[i]);
 _ftprintf(fp,_T("\r\n"));
 _ftprintf(fp,_T("    i\tpGridData2->pCtrlHdls[i]\r\n"));
 _ftprintf(fp,_T("    ==================================\r\n"));
 #endif
 int blnEditCreated = 0;
 int iCboCtr        = 0;
 for(unsigned int i=0; i<iCols; i++)
 {
     // Edit Control In Column
     if(pGridData2->pCellCtrlTypes[i]==GRID_CELL_CTRL_EDIT)
     {
        if(blnEditCreated==FALSE)
        {
           dwStyle = WS_CHILD | ES_AUTOHSCROLL;
           pGridData2->pCtrlHdls[i]=CreateWindowEx(0,_T("edit"),_T(""),dwStyle,0,0,0,0,Wea->hWnd,(HMENU)IDC_EDIT,Wea->hIns,0);
           pGridData2->hCtrlInCell=pGridData2->pCtrlHdls[i];
           blnEditCreated=TRUE;
        }
        else
        {
           pGridData2->pCtrlHdls[i]=pGridData2->hCtrlInCell;
        }
     }

     // Combo Box In Column
     if(pGridData2->pCellCtrlTypes[i]==GRID_CELL_CTRL_COMBO)
     {
        dwStyle=WS_CHILD | CBS_DROPDOWNLIST | WS_VSCROLL; //Or %CBS_NOINTEGRALHEIGHT
        pGridData2->pCtrlHdls[i]=CreateWindowEx(0,_T("combobox"),_T(""),dwStyle,0,0,0,0,Wea->hWnd,(HMENU)(IDC_COMBO+iCboCtr),Wea->hIns,0);
        iCboCtr++;
     }

     #if defined MYDEBUG
     _ftprintf(fp,_T("    %u\t\t%u\r\n"),i,pGridData2->pCtrlHdls[i]);
     #endif
 }
 pGridData2->hCtrlInCell=0;    //    DANGER!!!!!! Addition!  I don't know why this needes to be initially set?
 #if defined MYDEBUG
 _ftprintf(fp,_T("\r\n"));
 _ftprintf(fp,_T("    pGridData2->pColWidths[iCols] = %d\r\n"),pGridData2->pColWidths[iCols]);
 _ftprintf(fp,_T("\r\n"));
 #endif
 MoveWindow(Wea->hWnd,pCreateStruct->x,pCreateStruct->y,pCreateStruct->cx,iNewGridHt,FALSE);
 MoveWindow(pGridData2->hBase,SizX(12),0,rc.right-SizX(12),pGridData2->iPaneHeight,FALSE);
 MoveWindow(pGridData2->hPane,0,0,pGridData2->pColWidths[iCols],pGridData2->iPaneHeight,FALSE);
 MoveWindow(pGridData2->hHeader,0,0,pGridData2->pColWidths[iCols],pGridData2->iRowHeight,TRUE);
 delete [] strParseData;
 pGridData2->pVButtons=(HWND*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,(pGridData2->iVisibleRows+1)*sizeof(void*));
 #if defined MYDEBUG
 _ftprintf(fp,_T("    pGridData2->pVButtons = %u\r\n\r\n"),pGridData2->pVButtons);
 _ftprintf(fp,_T("    i\tpGridData2->pVButtons[i]\r\n"));
 _ftprintf(fp,_T("    ===================================\r\n"));
 #endif
 if(!pGridData2->pVButtons)
    goto CleanUp;
 else
 {
    for(unsigned int i=0; i<=pGridData2->iVisibleRows; i++)
    {                                                                                                                  // possibly SizX(12) ???
        pGridData2->pVButtons[i]=CreateWindowEx(0,_T("button"),_T(""),WS_CHILD|WS_VISIBLE|BS_FLAT,0,pGridData2->iRowHeight*i,SizX(12),pGridData2->iRowHeight,Wea->hWnd,(HMENU)(20000+i),Wea->hIns,0);
        #if defined MYDEBUG
        _ftprintf(fp,_T("    %u\t%u\r\n"),i,pGridData2->pVButtons[i]);
        #endif
    }
 }

 iHdlCount=pGridData2->iCols*pGridData2->iVisibleRows;
 pGridData2->pCellHandles=(HWND*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,iHdlCount*sizeof(void*));
 #if defined MYDEBUG
 _ftprintf(fp,_T("    iCols                    = %d\r\n"),iCols);
 _ftprintf(fp,_T("    pGridData2->iCols        = %u\r\n"),pGridData2->iCols);
 _ftprintf(fp,_T("    iHdlCount                = %d\r\n"),iHdlCount);
 _ftprintf(fp,_T("    pGridData2->pCellHandles = %u\r\n"),pGridData2->pCellHandles);
 #endif
 if(!pGridData2->pCellHandles)
    goto CleanUp;
 dwStyle=WS_CHILD | WS_VISIBLE | WS_BORDER;
 #if defined MYDEBUG
 _ftprintf(fp,_T("\r\n"));
 _ftprintf(fp,_T("    i\t\tj\tiPos(j)\tyLoc\thCell\r\n"));
 _ftprintf(fp,_T("    =============================================================\r\n"));
 #endif
 for(int i=0; i<pGridData2->iVisibleRows; i++)
 {
     for(int j=0; j<pGridData2->iCols; j++)
     {
         hCell=CreateWindowEx(0,_T("Cell"),_T(""),dwStyle,pPos[j],pGridData2->iRowHeight+(i*pGridData2->iRowHeight),pGridData2->pColWidths[j],pGridData2->iRowHeight,pGridData2->hPane,(HMENU)(ID_CELL+iCtr),Wea->hIns,0);
         pGridData2->pCellHandles[iCtr]=hCell;
         SetWindowLongPtr(hCell,sizeof(void*),(LONG_PTR)pGridData2->hFont);   // 4 for 32 bit; 8 for 64 bit
         #if defined MYDEBUG
         _ftprintf(fp,_T("    %d\t\t%d\t%u\t%d\t%u\r\n"),i,j,pPos[j],pGridData2->iRowHeight+(i*pGridData2->iRowHeight),hCell);
         #endif
         iCtr++;
     }
 }

 // grid memory
 iSize=pGridData2->iCols*pGridData2->iRows;
 pGridData2->pGridMemory=(TCHAR**)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,iSize*sizeof(void*));
 if(!pGridData2->pGridMemory)
    goto CleanUp;
 pGridData2->pTextColor=(COLORREF*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,iSize*sizeof(void*));
 if(!pGridData2->pTextColor)
    goto CleanUp;
 pGridData2->pBackColor=(HBRUSH*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,iSize*sizeof(void*));
 if(!pGridData2->pBackColor)
    goto CleanUp;
 pGridData2->pCreatedColors=(COLORREF*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,(MAX_COLORS+1)*sizeof(void*));
 if(!pGridData2->pCreatedColors)
    goto CleanUp;
 pGridData2->pCreatedBrushes=(HBRUSH*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,(MAX_COLORS+1)*sizeof(void*));
 if(!pGridData2->pCreatedBrushes)
    goto CleanUp;
 #ifdef MYDEBUG
 _ftprintf(fp,_T("    iSize                   = %d\r\n"),iSize);
 _ftprintf(fp,_T("    pGridData2->pGridMemory = %u\r\n"),pGridData2->pGridMemory);
 #endif

 //Done
 if(pPos)
    HeapFree(hHeap,0,pPos);
 #if defined MYDEBUG
 _ftprintf(fp,_T("    Everything Allocated OK!\r\n"));
 _ftprintf(fp,_T("  Leaving fnGridProc_OnCreate()\r\n\r\n"));
 #endif
 return 0;

 CleanUp:
 if(pGridData2->pColWidths)
 {
    HeapFree(hHeap,0,pGridData2->pColWidths);
    pGridData2->pColWidths=NULL;
 }
 if(pGridData2->pCellCtrlTypes)
 {
    HeapFree(hHeap,0,pGridData2->pCellCtrlTypes);
    pGridData2->pCellCtrlTypes=NULL;
 }
 if(pGridData2->pCtrlHdls)
 {
    HeapFree(hHeap,0,pGridData2->pCtrlHdls);
    pGridData2->pCtrlHdls=NULL;
 }
 if(pPos)
    HeapFree(hHeap,0,pPos);
 if(pGridData2->pVButtons)
 {
    HeapFree(hHeap,0,pGridData2->pVButtons);
    pGridData2->pVButtons=NULL;
 }
 if(pGridData2->hFont)
    DeleteObject(pGridData2->hFont);
 if(pGridData2->pCellHandles)
    HeapFree(hHeap,0,pGridData2->pCellHandles);
 if(pGridData2->pGridMemory)
    HeapFree(hHeap,0,pGridData2->pGridMemory);
 if(pGridData2->pTextColor)
    HeapFree(hHeap,0,pGridData2->pTextColor);
 if(pGridData2->pBackColor)
    HeapFree(hHeap,0,pGridData2->pBackColor);
 if(pGridData2->pCreatedColors)
    HeapFree(hHeap,0,pGridData2->pCreatedColors);
 if(pGridData2->pCreatedBrushes)
    HeapFree(hHeap,0,pGridData2->pCreatedBrushes);
 #if defined MYDEBUG
 _ftprintf(fp,_T("  Leaving fnGridProc_OnCreate()\r\n\r\n"));
 #endif

 return 0;
}


long fnGridProc_OnSize(lpWndEventArgs Wea)
{
 GridData* pGridData=NULL;
 SCROLLINFO si;
 int iCols;

 #if defined MYDEBUG
 _ftprintf(fp,_T("  Entering fnGridProc_OnSize()\r\n"));
 _ftprintf(fp,_T("    Wea->hWnd = %u\r\n"),Wea->hWnd);
 #endif
 pGridData=(GridData*)GetWindowLongPtr(Wea->hWnd,0);
 iCols=pGridData->iCols;
 #ifdef MYDEBUG
 _ftprintf(fp,_T("    pGridData    = %p\r\n"),pGridData);
 _ftprintf(fp,_T("    iCols        = %d\r\n"),iCols);
 #endif

 //Set Up Horizontal Scrollbar
 memset(&si, 0, sizeof(SCROLLINFO));
 si.cbSize = sizeof(SCROLLINFO);
 si.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS | SIF_DISABLENOSCROLL;
 si.nMin   = 0;
 si.nMax   = pGridData->pColWidths[iCols];
 si.nPage  = pGridData->cx-33; // 33 is the width of vert
 si.nPos   = 0;                // btns + width scroll bar + window edge
 SetScrollInfo(Wea->hWnd,SB_HORZ,&si,TRUE);
 #ifdef MYDEBUG
 _ftprintf(fp,_T("    Horizontal Scrollbar....\r\n"));
 _ftprintf(fp,_T("    si.nMin    = %d\r\n"),si.nMin);
 _ftprintf(fp,_T("    si.nMax    = %d\r\n"),si.nMax);
 _ftprintf(fp,_T("    si.nPos    = %d\r\n"),si.nPos);
 #endif

 //Set Up Verticle Scrollbar
 //ZeroMemory(&si, sizeof(SCROLLINFO));
 memset(&si, 0, sizeof(SCROLLINFO));
 si.cbSize = sizeof(SCROLLINFO);
 si.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS;
 si.nMin   = 1;
 si.nMax   = pGridData->iRows;
 si.nPage  = pGridData->iVisibleRows;
 si.nPos   = 1;
 SetScrollInfo(Wea->hWnd,SB_VERT,&si,TRUE);
 #ifdef MYDEBUG
 _ftprintf(fp,_T("    Verticle Scrollbar....\r\n"));
 _ftprintf(fp,_T("    si.nMin    = %d\r\n"), si.nMin);
 _ftprintf(fp,_T("    si.nMax    = %d\r\n"), si.nMax);
 _ftprintf(fp,_T("    si.nPos    = %d\r\n"), si.nPos);
 _ftprintf(fp,_T("    Leaving %WM_SIZE Case\r\n"));
 _ftprintf(fp,_T("  Leaving fnGridProc_OnSize()\r\n\r\n"));
 #endif

 return 0;
}


long fnGridProc_OnHScroll(lpWndEventArgs Wea)
{
 GridData* pGridData=NULL;
 int iCols,iScrollPos;
 SCROLLINFO si;

 #if defined MYDEBUG
 _ftprintf(fp,_T("Entering fnGridProc_OnHScroll()\r\n"));
 _ftprintf(fp,_T("  Wea->hWnd = %p\r\n"),Wea->hWnd);
 #endif
 //ZeroMemory(&si, sizeof(SCROLLINFO));
 memset(&si, 0, sizeof(SCROLLINFO));
 pGridData = (GridData*)GetWindowLongPtr(Wea->hWnd,0);
 iCols     = pGridData->iCols;
 si.cbSize = sizeof(SCROLLINFO);
 si.fMask  = SIF_ALL;
 GetScrollInfo(pGridData->hGrid,SB_HORZ,&si);
 iScrollPos=si.nPos;
 #ifdef MYDEBUG
 _ftprintf(fp,_T("    Before Adjustments\r\n"));
 _ftprintf(fp,_T("    si.nMin    = %d\r\n"), si.nMin);
 _ftprintf(fp,_T("    si.nMax    = %d\r\n"), si.nMax);
 _ftprintf(fp,_T("    si.nPos    = %d\r\n"), si.nPos);
 #endif
 switch(LOWORD(Wea->wParam))
 {
   case SB_LINELEFT:
     {
        if(si.nPos > si.nMin)
           si.nPos=si.nPos-50;
        break;
     }
   case SB_PAGELEFT:
     {
        si.nPos = si.nPos - si.nPage;
        break;
     }
   case SB_LINERIGHT:
     {
        if(si.nPos<si.nMax)
           si.nPos=si.nPos+50;
        break;
     }
   case SB_PAGERIGHT:
     {
        si.nPos = si.nPos + si.nPage;
        break;
     }
   case SB_THUMBTRACK:
     {
        si.nPos=si.nTrackPos;
        break;
     }
 }
 si.fMask = SIF_POS;
 SetScrollInfo(pGridData->hGrid,SB_HORZ,&si,TRUE);
 GetScrollInfo(pGridData->hGrid,SB_HORZ,&si);
 if(iScrollPos!=si.nPos)
 {
    if(si.nPos==0)
       SetWindowPos(pGridData->hPane,HWND_TOP,0,0,pGridData->pColWidths[iCols],pGridData->iPaneHeight,SWP_SHOWWINDOW);
    else
       SetWindowPos(pGridData->hPane,HWND_TOP,-si.nPos,0,pGridData->pColWidths[iCols],pGridData->iPaneHeight,SWP_SHOWWINDOW);
 }
 #ifdef MYDEBUG
 _ftprintf(fp,_T("    After All Adjustments\r\n"));
 _ftprintf(fp,_T("    si.nMin    = %d\r\n"),si.nMin);
 _ftprintf(fp,_T("    si.nMax    = %d\r\n"),si.nMax);
 _ftprintf(fp,_T("    si.nPos    = %d\r\n"),si.nPos);
 _ftprintf(fp,_T("    Leaving %WM_HSCROLL Case\r\n"));
 _ftprintf(fp,_T("Leaving fnGridProc_OnHScroll()\r\n\r\n"));
 #endif

 return 0;
}


long fnGridProc_OnVScroll(lpWndEventArgs Wea)
{
 GridData* pGridData=NULL;
 int iCols,iScrollPos;
 SCROLLINFO si;
 HWND hCell;

 #if defined MYDEBUG
 _ftprintf(fp,_T("Entering fnGridProc_OnVScroll()\r\n"));
 _ftprintf(fp,_T("  Wea->hWnd        = %u\r\n"),Wea->hWnd);
 #endif
 //ZeroMemory(&si, sizeof(SCROLLINFO));
 memset(&si, 0, sizeof(SCROLLINFO));
 pGridData = (GridData*)GetWindowLongPtr(Wea->hWnd,0);
 pGridData->pComObj->FlushData();
 si.cbSize = sizeof(SCROLLINFO);
 si.fMask  = SIF_ALL;
 GetScrollInfo(pGridData->hGrid,SB_VERT,&si);
 iScrollPos=si.nPos;
 #ifdef MYDEBUG
 _ftprintf(fp,_T("  Before Adjustments\r\n"));
 _ftprintf(fp,_T("  si.nMin          = %d\r\n"), si.nMin);
 _ftprintf(fp,_T("  si.nMax          = %d\r\n"), si.nMax);
 _ftprintf(fp,_T("  si.nPos          = %d\r\n"), si.nPos);
 _ftprintf(fp,_T("  pGridData->hGrid = %u\r\n"), pGridData->hGrid);
 _ftprintf(fp,_T("  pGridData        = %u\r\n"), pGridData);
 #endif
 switch(LOWORD(Wea->wParam))             // this originally didn't work
 {
    case SB_LINEUP:
      {
         if(si.nPos > si.nMin)
            si.nPos=si.nPos-1;
         break;
      }
    case SB_PAGEUP:
      {
         si.nPos = si.nPos - si.nPage;
         break;
      }
    case SB_LINEDOWN:
      {
         if(si.nPos<si.nMax)
            si.nPos=si.nPos+1;
         break;
      }
    case SB_PAGEDOWN:
      {
         si.nPos = si.nPos + si.nPage;
         break;
      }
    case SB_THUMBTRACK:
      {
         si.nPos=si.nTrackPos;
         break;
      }
 }
 si.fMask=SIF_POS;
 SetScrollInfo(pGridData->hGrid,SB_VERT,&si,TRUE);
 GetScrollInfo(pGridData->hGrid,SB_VERT,&si);
 if(iScrollPos!=si.nPos)
 {
     int iNum,iLast;
     iNum=pGridData->iCols*(si.nPos-1);
     iLast=(pGridData->iCols * pGridData->iVisibleRows) - 1;
     for(int i=0; i<=iLast; i++)
     {
       hCell=pGridData->pCellHandles[i];
       SetWindowLongPtr(hCell,0,(LONG_PTR)pGridData->pGridMemory[iNum]);
       SetWindowLongPtr(hCell,2*sizeof(void*),(LONG_PTR)pGridData->pTextColor[iNum]);
       SetWindowLongPtr(hCell,3*sizeof(void*),(LONG_PTR)pGridData->pBackColor[iNum]);
       iNum++;
     }
 }
 InvalidateRect(pGridData->hGrid,NULL,TRUE);
 #ifdef MYDEBUG
 _ftprintf(fp,_T("  After All Adjustments\r\n"));
 _ftprintf(fp,_T("  si.nMin    = %d\r\n"),si.nMin);
 _ftprintf(fp,_T("  si.nMax    = %d\r\n"),si.nMax);
 _ftprintf(fp,_T("  si.nPos    = %d\r\n"),si.nPos);
 _ftprintf(fp,_T("  Leaving %WM_VSCROLL Case\r\n"));
 _ftprintf(fp,_T("Leaving fnGridProc_OnVScroll()\r\n\r\n"));
 #endif

 return 0;
}


long fnGridProc_OnKeyDown(lpWndEventArgs Wea)
{
 #if defined MYDEBUG
 _ftprintf(fp,_T("Entering fnGridProc_OnKeyDown()\r\n"));
 _ftprintf(fp,_T("  Wea->hWnd = %p\r\n"),Wea->hWnd);
 #endif
 if(Wea->wParam==VK_DELETE)
 {
    GridData* pGridData=(GridData*)GetWindowLongPtr(Wea->hWnd,0);
    if(pGridData->blnRowSelected)
    {
       #if defined MYDEBUG
       _ftprintf(fp,_T("  pGridData = %p\r\n"),pGridData);
       _ftprintf(fp,_T("  A Row Is Selected, Namely, Row #%d\r\n"),pGridData->iSelectedRow);
       #endif
       for(int i=0; i<MAX_CONNECTIONS; i++)
       {
           if(pGridData->pComObj->pISink[i])
              pGridData->pComObj->pISink[i]->Grid_OnDelete(pGridData->iSelectedRow);
       }
       pGridData->pComObj->Refresh();
    }
 }
 #if defined MYDEBUG
 _ftprintf(fp,_T("Leaving fnGridProc_OnKeyDown()\r\n\r\n"));
 #endif

 return 0;
}


long fnGridProc_OnCommand(lpWndEventArgs Wea)
{
 #if defined MYDEBUG
 _ftprintf(fp,_T("Entering fnGridProc_OnCommand()\r\n"));
 _ftprintf(fp,_T("  Wea->hWnd = %p\r\n"),Wea->hWnd);
 _ftprintf(fp,_T("  LOWORD(Wea->wParam) = %d\r\n"),LOWORD(Wea->wParam));
 #endif
 if(LOWORD(Wea->wParam)>20000)
 {
    GridData* pGridData=(GridData*)GetWindowLongPtr(Wea->hWnd,0);
    pGridData->pComObj->FlushData();
    SCROLLINFO si;
    //ZeroMemory(&si, sizeof(SCROLLINFO));
    memset(&si, 0, sizeof(SCROLLINFO));
    si.cbSize = sizeof(SCROLLINFO);
    si.fMask=SIF_POS;
    GetScrollInfo(pGridData->hGrid,SB_VERT,&si);
    int iCellRow=LOWORD(Wea->wParam)-20000;
    int iGridRow=si.nPos+iCellRow-1;
    #if defined MYDEBUG
    _ftprintf(fp,_T("  iCellRow = %d\r\n"),iCellRow);
    _ftprintf(fp,_T("  iGridRow = %d\r\n"),iGridRow);
    _ftprintf(fp,_T("  pGridData->blnRowSelected = %d\r\n"),pGridData->blnRowSelected);
    #endif
    if(pGridData->blnRowSelected)
    {
       if(iGridRow==pGridData->iSelectedRow)
       {
           #ifdef MYDEBUG
           _ftprintf(fp,_T("  We Got In Where iGridRow = @pGridData.iSelectedRow!\r\n"));
           #endif
           for(int i=1; i<=pGridData->iCols; i++)
               pGridData->pComObj->SetCellAttributes(pGridData->iSelectedRow,i,0x00FFFFFF,0);
           pGridData->iSelectedRow=0, pGridData->blnRowSelected=FALSE;
       }
       else
       {
           #ifdef MYDEBUG
           _ftprintf(fp,_T("  We Got In Where iGridRow != pGridData->iSelectedRow!\r\n"));
           #endif
           for(int i=1; i<=pGridData->iCols; i++)
               pGridData->pComObj->SetCellAttributes(pGridData->iSelectedRow,i,0x00FFFFFF,0);
           pGridData->iSelectedRow=iGridRow;
           for(int i=1; i<=pGridData->iCols; i++)
               pGridData->pComObj->SetCellAttributes(iGridRow,i,pGridData->iSelectionBackColor,pGridData->iSelectionTextColor);
       }
    }
    else
    {
       #ifdef MYDEBUG
       _ftprintf(fp,_T("  We Got In Where pGridData->blnSelected = FALSE!\r\n"));
       _ftprintf(fp,_T("  pGridData->iSelectionBackColor         = 0x%x\r\n"),pGridData->iSelectionBackColor);
       _ftprintf(fp,_T("  pGridData->iSelectionTextColor         = 0x%x\r\n"),pGridData->iSelectionTextColor);
       #endif
       for(int i=1; i<=pGridData->iCols; i++)
           pGridData->pComObj->SetCellAttributes(iGridRow,i,pGridData->iSelectionBackColor,pGridData->iSelectionTextColor);
       pGridData->blnRowSelected=TRUE;
       pGridData->iSelectedRow=iGridRow;
       #ifdef MYDEBUG
       _ftprintf(fp,_T("  pGridData.iSelectedRow    = %d\r\n"),pGridData->iSelectedRow);
       _ftprintf(fp,_T("  pGridData->blnRowSelected = %d\r\n"),pGridData->blnRowSelected);
       #endif
    }
    pGridData->pComObj->Refresh();
    for(int i=0; i<MAX_CONNECTIONS; i++)
    {
        if(pGridData->pComObj->pISink[i])
           pGridData->pComObj->pISink[i]->Grid_OnRowSelection(iGridRow,pGridData->blnRowSelected);
    }
    SetFocus(Wea->hWnd);
 }
 #if defined MYDEBUG
 _ftprintf(fp,_T("Leaving fnGridProc_OnCommand()\r\n\r\n"));
 #endif

 return 0;
}


long fnGridProc_OnDestroy(lpWndEventArgs Wea)
{
 GridData* pGridData=NULL;
 HANDLE hHeap=NULL;
 TCHAR* pMem=NULL;
 BOOL blnFree=0;
 int iCtr=0,i,j;

 #if defined MYDEBUG
 _ftprintf(fp,_T("Entering fnGridProc_OnDestroy()\r\n"));
 #endif
 pGridData=(GridData*)GetWindowLongPtr(Wea->hWnd,0);
 #if defined MYDEBUG
 _ftprintf(fp,_T("  Wea->hWnd                           = %p\r\n"),Wea->hWnd);
 _ftprintf(fp,_T("  pGridData                           = %p\r\n\r\n"),pGridData);
 #endif
 if(pGridData)
 {
    #if defined MYDEBUG
    _ftprintf(fp,_T("  i\tpGridData->pColWidths[i]\r\n"));
    _ftprintf(fp,_T("  =============================\r\n"));
    for(i=0; i<5; i++)
        _ftprintf(fp,_T("  %u\t%u\r\n"),i,pGridData->pColWidths[i]);
    _ftprintf(fp,_T("\n  pGridData->pColWidths[5]            = %u\r\n"),pGridData->pColWidths[5]);
    #endif

    hHeap=GetProcessHeap();
    if(hHeap)
    {
       #if defined MYDEBUG
       _ftprintf(fp,_T("  pGridData->pColWidths               = %u\r\n"),pGridData->pColWidths);
       #endif
       if(pGridData->pColWidths)
          blnFree=HeapFree(hHeap,0,pGridData->pColWidths);
       #if defined MYDEBUG
       _ftprintf(fp,_T("  blnFree(pGridData->pColWidths)      = %u\r\n"),blnFree);
       #endif
       if(pGridData->pCellCtrlTypes)
          blnFree=HeapFree(hHeap,0,pGridData->pCellCtrlTypes);
       #if defined MYDEBUG
       _ftprintf(fp,_T("  blnFree(pGridData->pCellCtrlTypes)  = %u\r\n"),blnFree);
       #endif
       if(pGridData->pCtrlHdls)
          blnFree=HeapFree(hHeap,0,pGridData->pCtrlHdls);
       #if defined MYDEBUG
       _ftprintf(fp,_T("  blnFree(pGridData->pCtrlHdls)       = %u\r\n"),blnFree);
       #endif
       if(pGridData->pVButtons)
       {
          blnFree=HeapFree(hHeap,0,pGridData->pVButtons);
          pGridData->pVButtons=NULL;
          #if defined MYDEBUG
          _ftprintf(fp,_T("  blnFree(pGridData->pVButtons)       = %u\r\n"),blnFree);
          #endif
       }

       if(pGridData->hFont)
       {
          blnFree=DeleteObject(pGridData->hFont);
          #if defined MYDEBUG
          _ftprintf(fp,_T("  blnFree(pGridData->hFont)           = %u\r\n"),blnFree);
          #endif
       }

       if(pGridData->pCellHandles)
       {
          blnFree=HeapFree(hHeap,0,pGridData->pCellHandles);
          #if defined MYDEBUG
          _ftprintf(fp,_T("  blnFree(pGridData->pCellHandles)    = %u\r\n"),blnFree);
          #endif
          blnFree=0;
       }

       #if defined MYDEBUG
       _ftprintf(fp,_T("\n"));
       _ftprintf(fp,_T("  i             j               iCtr            pMem            pMem            blnFree\r\n"));
       _ftprintf(fp,_T("  =====================================================================================\r\n"));
       #endif
       for(i=1; i<=pGridData->iRows; i++)
       {
         for(j=1; j<=pGridData->iCols; j++)
         {
           pMem=pGridData->pGridMemory[iCtr];
           if(pMem)
           {
              #if defined MYDEBUG
              _ftprintf(fp,_T("  %d\t\t%d\t\t%d\t\t%u\t\t%s\t\t"),i,j,iCtr,pMem,pMem);
              #endif
              blnFree=HeapFree(hHeap,0,pMem);
              pMem=NULL;
              #ifdef MYDEBUG
              _ftprintf(fp,_T("%d\r\n"),blnFree);
              #endif
              blnFree=0;
           }
           else
           {
              #if defined MYDEBUG
              _ftprintf(fp,_T("  %d\t\t%d\t\t%d\t\t%u\t\t%s\t\t%d\r\n"),i,j,iCtr,pMem,pMem,blnFree);
              #endif
           }
           iCtr++;
         }
       }

       if(pGridData->pGridMemory)
       {
          blnFree=HeapFree(hHeap,0,pGridData->pGridMemory);
          #if defined MYDEBUG
          _ftprintf(fp,_T("\n  blnFree(pGridData->pGridMemory)     = %u\r\n"),blnFree);
          #endif
       }
       if(pGridData->pTextColor)
       {
          blnFree=HeapFree(hHeap,0,pGridData->pTextColor);
          #if defined MYDEBUG
          _ftprintf(fp,_T("  blnFree(pGridData->pTextColor)      = %u\r\n"),blnFree);
          #endif
       }
       if(pGridData->pBackColor)
       {
          blnFree=HeapFree(hHeap,0,pGridData->pBackColor);
          #if defined MYDEBUG
          _ftprintf(fp,_T("  blnFree(pGridData->pBackColor)      = %u\r\n"),blnFree);
          #endif
       }

       #if defined MYDEBUG
       _ftprintf(fp,_T("  pGridData->pCreatedBrushes[0]       = %d\r\n"),pGridData->pCreatedBrushes[0]);
       _ftprintf(fp,_T("  pGridData->pCreatedColors[0]        = %d\r\n\r\n"),pGridData->pCreatedColors[0]);
       _ftprintf(fp,_T("  i\tDeleteObject(i)\r\n"));
       _ftprintf(fp,_T("  =====================\r\n"));
       #endif
       for(i=1; i<=(int)pGridData->pCreatedBrushes[0]; i++)
       {
           if(pGridData->pCreatedBrushes[i])
           {
              blnFree=DeleteObject(pGridData->pCreatedBrushes[i]);
              #if defined MYDEBUG
              _ftprintf(fp,_T("  %d\t%d\r\n"),i,blnFree);
              #endif
           }
       }
       if(pGridData->pCreatedColors)
       {
          blnFree=HeapFree(hHeap,0,pGridData->pCreatedColors);
          #if defined MYDEBUG
          _ftprintf(fp,_T("\n  blnFree(pGridData->pCreatedColors)  = %d\r\n"),blnFree);
          #endif
       }
       if(pGridData->pCreatedBrushes)
       {
          blnFree=HeapFree(hHeap,0,pGridData->pCreatedBrushes);
          #if defined MYDEBUG
          _ftprintf(fp,_T("  blnFree(pGridData->pCreatedBrushes) = %d\r\n"),blnFree);
          #endif
       }
       blnFree=HeapFree(hHeap,0,pGridData);
       #if defined MYDEBUG
       _ftprintf(fp,_T("  blnFree                             = %d\r\n"),blnFree);
       #endif
    }
 }
 #if defined MYDEBUG
 _ftprintf(fp,_T("Leaving fnGridProc_OnDestroy()\r\n\r\n"));
 #endif

 return 0;
}


LRESULT CALLBACK fnGridProc(HWND hwnd, unsigned int msg, WPARAM wParam, LPARAM lParam)
{
 WindowsEventArguments Wea;

 for(unsigned int i=0; i<7; i++)     // dim(EventHandler); i++)
 {
     if(EventHandler[i].iMsg==msg)
     {
        Wea.hWnd=hwnd, Wea.lParam=lParam, Wea.wParam=wParam;
        return (*EventHandler[i].fnPtr)(&Wea);
     }
 }

 return (DefWindowProc(hwnd, msg, wParam, lParam));
}


LRESULT CALLBACK fnPaneProc(HWND hPane, unsigned int msg, WPARAM wParam, LPARAM lParam)
{
 if(msg==WM_NOTIFY)
 {
    int iCols,iRange,index,iHt;
    GridData* pGridData=NULL;
    NMHEADER* pNotify=NULL;
    SCROLLINFO si;

    #if defined MYDEBUG
    _ftprintf(fp,_T("Entering fnPaneProc() -- WM_NOTIFY Case\r\n"));
    #endif
    pNotify=(NMHEADER*)lParam;
    pGridData=(GridData*)GetWindowLongPtr(hPane,0);
    iCols=pGridData->iCols;
    #ifdef MYDEBUG
    _ftprintf(fp,_T("  pGridData              = %p\r\n"),pGridData);
    _ftprintf(fp,_T("  pGridData->iCols       = %d\r\n"),pGridData->iCols);
    _ftprintf(fp,_T("  pGridData->pComObj     = %p\r\n"),pGridData->pComObj);
    _ftprintf(fp,_T("  pGridData->hCtrlInCell = %p\r\n"),pGridData->hCtrlInCell);
    #endif
    switch(pNotify->hdr.code)
    {
      case HDN_TRACK:
        {
           #ifdef MYDEBUG
           _ftprintf(fp,_T("  Got HDN_TRACK Notification\r\n"));
           #endif
           if(pGridData->hCtrlInCell)
           {
              pGridData->pComObj->FlushData();
              pGridData->pComObj->Refresh();
           }
           if(pGridData->pColWidths)
           {
              pGridData->pColWidths[pNotify->iItem]=pNotify->pitem->cxy;
              #ifdef MYDEBUG
              _ftprintf(fp,_T("  pNotify->iItem         = %d\r\n"),pNotify->iItem);
              _ftprintf(fp,_T("  pNotify->pitem->cxy    = %d\r\n"),pNotify->pitem->cxy);
              #endif
           }
           pGridData->pColWidths[iCols]=0;
           for(int i=0; i<iCols; i++)
               pGridData->pColWidths[iCols]=pGridData->pColWidths[iCols]+pGridData->pColWidths[i];

           si.cbSize = sizeof(SCROLLINFO);
           si.fMask  = SIF_RANGE|SIF_PAGE|SIF_DISABLENOSCROLL;
           si.nMin   = 0;
           si.nMax   = pGridData->pColWidths[iCols];
           si.nPage  = pGridData->cx-33;
           iRange    = si.nMax-si.nMin;
           SetScrollInfo(pGridData->hGrid,SB_HORZ,&si,TRUE);
           if(iRange>si.nPage)
              SetWindowPos(pGridData->hPane,HWND_TOP,0,0,pGridData->pColWidths[iCols],pGridData->cy,SWP_NOMOVE|SWP_SHOWWINDOW);
           else
              SetWindowPos(pGridData->hPane,HWND_TOP,0,0,pGridData->pColWidths[iCols],pGridData->cy,SWP_SHOWWINDOW);
           SetWindowPos(pGridData->hHeader,HWND_BOTTOM,0,0,pGridData->pColWidths[iCols],pGridData->iRowHeight,SWP_NOMOVE|SWP_SHOWWINDOW);
           #ifdef MYDEBUG
           _ftprintf(fp,_T("    si.nMin                       = %u\r\n"),si.nMin);
           _ftprintf(fp,_T("    si.nMax                       = %u\r\n"),si.nMax);
           _ftprintf(fp,_T("    si.nPage                      = %u\r\n"),si.nPage);
           _ftprintf(fp,_T("    iRange                        = %d\r\n"),iRange);
           _ftprintf(fp,_T("    pGridData->pColWidths[iCols]  = %d\r\n"),pGridData->pColWidths[iCols]);
           #endif

           HANDLE hHeap=GetProcessHeap();
           int* pPos=(int*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,iCols*sizeof(int));
           if(!pPos)
              return 0;
           for(int i=1; i<iCols; i++)
               pPos[i]=pPos[i-1]+pGridData->pColWidths[i-1];
           if(pGridData->pCellHandles)
           {
              for(int i=0; i<pGridData->iVisibleRows; i++)
              {
                  for(int j=0; j<iCols; j++)
                  {
                      index=iCols*i+j;
                      iHt=pGridData->iRowHeight;
                      MoveWindow(pGridData->pCellHandles[index], pPos[j], iHt+(i*iHt), pGridData->pColWidths[j], iHt, FALSE);
                  }
              }
              InvalidateRect(pGridData->hGrid,NULL,TRUE);
           }
           HeapFree(hHeap,0,pPos);
           break;
        }
      case HDN_ENDTRACK:
        {
           #if defined MYDEBUG
           _ftprintf(fp,_T("  Got HDN_TRACK Notification\r\n"));
           #endif
           InvalidateRect(pGridData->hGrid,0,TRUE);
           break;
        }
    }
    #if defined MYDEBUG
    _ftprintf(fp,_T("Leaving fnPaneProc() -- WM_NOTIFY Case\r\n\r\n"));
    #endif
 }

 return (DefWindowProc(hPane, msg, wParam, lParam));
}


LRESULT CALLBACK fnBaseProc(HWND hwnd, unsigned int msg, WPARAM wParam, LPARAM lParam)
{
 return (DefWindowProc(hwnd, msg, wParam, lParam));
}


LRESULT CALLBACK fnEditSubClass(HWND hEdit, UINT msg, WPARAM wParam, LPARAM lParam)
{
 int blnCancel=0;
 HWND hCell=GetParent(hEdit);
 HWND hPane=GetParent(hCell);
 HWND hBase=GetParent(hPane);
 HWND hGrid=GetParent(hBase);
 GridData* pGridData=(GridData*)GetWindowLongPtr(hGrid,0);
 switch(msg)
 {
   case WM_CHAR:
     {
        #ifdef MYDEBUG
        _ftprintf(fp,_T("Entering fnEditSubClass()  -- Case WM_CHAR\r\n"));
        _ftprintf(fp,_T("  hEdit     = %p\r\n"),hEdit);
        _ftprintf(fp,_T("  hCell     = %p\r\n"),hCell);
        _ftprintf(fp,_T("  hPane     = %p\r\n"),hPane);
        _ftprintf(fp,_T("  hBase     = %p\r\n"),hBase);
        _ftprintf(fp,_T("  hGrid     = %p\r\n"),hGrid);
        _ftprintf(fp,_T("  pGridData = %p\r\n"),pGridData);
        _ftprintf(fp,_T("  wParam    = %c\r\n"),wParam);
        #endif
        for(int i=0; i<MAX_CONNECTIONS; i++)
        {
            if(pGridData->pComObj->pISink[i])
            {
               pGridData->pComObj->pISink[i]->Grid_OnKeyPress((int)wParam, (int)lParam, pGridData->iEditedRow, pGridData->iEditedCol, &blnCancel);
               if(blnCancel)
                  return 0;
            }
        }
        if(wParam==VK_RETURN)
        {
           pGridData->pComObj->FlushData();
           pGridData->pComObj->Refresh();
           return 0;
        }
        else
           pGridData->hCtrlInCell=hEdit;
        #ifdef MYDEBUG
        _ftprintf(fp,_T("Leaving fnEditSubClass()\r\n"));
        #endif
        break;
     }
   case WM_KEYDOWN:
     {
        #ifdef MYDEBUG
        _ftprintf(fp,_T("Entering fnEditSubClass()  -- Case WM_KEYDOWN\n"));
        _ftprintf(fp,_T("  hEdit = %p\r\n"),hEdit);
        _ftprintf(fp,_T("  hCell = %p\r\n"),hCell);
        _ftprintf(fp,_T("  hPane = %p\r\n"),hPane);
        _ftprintf(fp,_T("  hBase = %p\r\n"),hBase);
        _ftprintf(fp,_T("  hGrid = %p\r\n"),hGrid);
        _ftprintf(fp,_T("  pGridData = %p\r\n"),pGridData);
        #endif
        for(int i=0; i<MAX_CONNECTIONS; i++)
        {
            if(pGridData->pComObj->pISink[i])
            {
               pGridData->pComObj->pISink[i]->Grid_OnKeyDown((int)wParam, (int)lParam, pGridData->iEditedCellRow, pGridData->iEditedRow, pGridData->iEditedCol, &blnCancel);
               if(blnCancel)
                  return 0;
            }
        }
        #ifdef MYDEBUG
        _ftprintf(fp,_T("Leaving fnEditSubClass()\r\n"));
        #endif
        break;
     }
   case WM_PASTE:
     {
        for(int i=0; i<MAX_CONNECTIONS; i++)
        {
            if(pGridData->pComObj->pISink[i])
            {
               pGridData->pComObj->pISink[i]->Grid_OnPaste(pGridData->iEditedCellRow, pGridData->iEditedRow, pGridData->iEditedCol);
               if(blnCancel)
                  return 0;
            }
        }
        break;
     }
   case WM_LBUTTONDBLCLK:
     {
        for(int i=0; i<MAX_CONNECTIONS; i++)
        {
            if(pGridData->pComObj->pISink[i])
            {
               pGridData->pComObj->pISink[i]->Grid_OnLButtonDblClk(pGridData->iEditedCellRow, pGridData->iEditedRow, pGridData->iEditedCol);
               if(blnCancel)
                  return 0;
            }
        }
        break;
     }

 }

 return CallWindowProc(fnEditWndProc,hEdit,msg,wParam,lParam);
}


BOOL CALLBACK EnumGridProc(HWND hWnd, LPARAM lParam)
{
 #ifdef MYDEBUG
 _ftprintf(fp,_T("  Called EnumGridProc() - %p\t%u\r\n"),hWnd,lParam);
 #endif
 if(GetClassLongPtr(hWnd,GCLP_WNDPROC)==lParam)
 {
    #ifdef MYDEBUG
    _ftprintf(fp,_T("\r\n  Made A Match! - %p\t%u\r\n\r\n"),hWnd,lParam);
    #endif
    GridData* pGridData=(GridData*)GetWindowLongPtr(hWnd,0);
    pGridData->pComObj->FlushData();
 }

 return TRUE;
}


/*
' Offset     What's Stored There in WNDCLASSEX::cbWndExtra Bytes
' ==============================================================
' 0  -  3    pZStr, i.e., pointer to string data (ZStr) for cell      0  -  7
' 4  -  7    hFont, i.e., this was created in fnWndProc_OnCreate      8  -  15
' 8  - 11    dwColor, i.e., text color, and an RGB value             16  -  23
' 12 - 15    HBrush, and this is a HANDLE                            24  -  31
*/

LRESULT CALLBACK fnCellProc(HWND hCell, unsigned int msg, WPARAM wParam, LPARAM lParam)
{
 switch(msg)
 {
   case WM_CREATE:
     {
        SetWindowLongPtr(hCell,0,NULL);
        return 0;
     }
   case WM_LBUTTONDOWN:
     {
        int iCellBufferPos=0,blnFound=0,iGridMemOffset=0,iRow,iCol,i,j;
        HWND hGrid=NULL,hBase=NULL,hPane=NULL;
        GridData* pGridData=NULL;
        TCHAR* pZStr=NULL;
        SCROLLINFO si;
        HRESULT hr;
        #ifdef MYDEBUG
        _ftprintf(fp,_T("\r\nEntering fnCellProc()  --  case WM_LBUTTONDOWN\r\n"));
        #endif
        hPane=GetParent(hCell);
        hBase=GetParent(hPane);
        hGrid=GetParent(hBase);
        pGridData=(GridData*)GetWindowLongPtr(hPane,0);
        #ifdef MYDEBUG
        _ftprintf(fp,_T("  hCell              = %p\r\n"),hCell);
        _ftprintf(fp,_T("  hPane              = %p\r\n"),hPane);
        _ftprintf(fp,_T("  hBase              = %p\r\n"),hBase);
        _ftprintf(fp,_T("  hGrid              = %p\r\n"),hGrid);
        _ftprintf(fp,_T("  pGridData->hParent = %p\r\n"),pGridData->hParent);
        #endif
        EnumChildWindows(pGridData->hParent,EnumGridProc,(LPARAM)fnGridProc);
        //ZeroMemory(&si, sizeof(SCROLLINFO));
        memset(&si, 0, sizeof(SCROLLINFO));
        si.cbSize = sizeof(SCROLLINFO), si.fMask=SIF_POS;
        GetScrollInfo(hGrid,SB_VERT,&si);
        for(i=1; i<=pGridData->iVisibleRows; i++)
        {
            for(j=1; j<=pGridData->iCols; j++)
            {
                iCellBufferPos = dwIdx(i,j);
                if(pGridData->pCellHandles[iCellBufferPos]==hCell)
                {
                   iGridMemOffset = pGridData->iCols * (si.nPos -1) + iCellBufferPos;
                   pZStr=pGridData->pGridMemory[iGridMemOffset];
                   iRow=i, iCol=j;
                   pGridData->iEditedCellRow=iRow;
                   pGridData->iEditedRow=iRow+si.nPos-1;
                   pGridData->iEditedCol=iCol;
                   blnFound=TRUE;
                   goto Finished;
                }
          }
        }
        Finished:
        if(blnFound)
        {
           #ifdef MYDEBUG
           _ftprintf(fp,_T("  Found ZStr at %d\t%d\r\n"),i,j);
           _ftprintf(fp,_T("  si.nPos                = %u\r\n"),si.nPos);
           _ftprintf(fp,_T("  pZStr                  = %p\r\n"),pZStr);
           _ftprintf(fp,_T("  pZStr                  = %s\r\n"),pZStr);
           _ftprintf(fp,_T("  pGridData->hCtrlInCell = %p\r\n"),pGridData->hCtrlInCell);
           #endif
           pGridData->hCtrlInCell=pGridData->pCtrlHdls[iCol-1];
           SetParent(pGridData->hCtrlInCell,hCell);
           fnEditWndProc=(WNDPROC)SetWindowLongPtr(pGridData->hCtrlInCell,GWLP_WNDPROC,(LONG_PTR)fnEditSubClass);
           if(pGridData->hFont)
              SendMessage(pGridData->hCtrlInCell,WM_SETFONT,(WPARAM)pGridData->hFont,(LPARAM)TRUE);
           if(pGridData->pCellCtrlTypes[iCol-1]==GRID_CELL_CTRL_EDIT)
           {
              SetWindowPos(pGridData->hCtrlInCell,HWND_TOP,1,0,pGridData->pColWidths[iCol-1]-2,pGridData->iRowHeight,SWP_SHOWWINDOW);
              SetWindowText(pGridData->hCtrlInCell,pZStr);
              SetFocus(pGridData->hCtrlInCell);
              SendMessage(pGridData->hCtrlInCell,EM_SETSEL,(WPARAM)0,(LPARAM)-1);
           }
           if(pGridData->pCellCtrlTypes[iCol-1]==GRID_CELL_CTRL_COMBO)
           {
              SetWindowPos(pGridData->hCtrlInCell,HWND_TOP,1,0,pGridData->pColWidths[iCol-1]-2,180,SWP_SHOWWINDOW);
              SendMessage(pGridData->hCtrlInCell,CB_SETCURSEL,(WPARAM)-1,(LPARAM)0);
           }
           for(i=0; i<MAX_CONNECTIONS; i++)
           {
               if(pGridData->pComObj->pISink[i])
               {
                  pGridData->pComObj->pISink[i]->Grid_OnLButtonDown(iRow,pGridData->iEditedRow,iCol);
               }
           }
        }
        #ifdef MYDEBUG
        _ftprintf(fp,_T("Leaving fnCellProc()  --  case WM_LBUTTONDOWN\r\n\r\n"));
        #endif
        return 0;
     }
   case WM_PAINT:
     {
        #ifdef MYDEBUG
        _ftprintf(fp,_T("\r\nEntering fnCellProc()  --  case WM_PAINT\r\n"));
        #endif
        PAINTSTRUCT ps;
        HDC hDC=BeginPaint(hCell,&ps);
        TCHAR* pBuffer=(TCHAR*)GetWindowLongPtr(hCell,0);                   // 0
        HFONT hFont=(HFONT)GetWindowLongPtr(hCell,sizeof(void*));           // 8
        COLORREF dwColor=(COLORREF)GetWindowLongPtr(hCell,2*sizeof(void*)); // 16
        HBRUSH hBrush=(HBRUSH)GetWindowLongPtr(hCell,3*sizeof(void*));      // 24
        #ifdef MYDEBUG
        _ftprintf(fp,_T("  pBuffer = %p\t%s\r\n"),pBuffer,pBuffer);
        _ftprintf(fp,_T("  hBrush  = %p\r\n"),hBrush);
        #endif
        if(hBrush)                                           // had a tremendous amount of trouble here.
        {                                                    // if this block of code dealing with FillRect()
           RECT rc;                                          // is inside the if(pBuffer) if, it won't execute
           HBRUSH hTmpBr=(HBRUSH)SelectObject(hDC,hBrush);   // to change the backround color of a cell if
           GetClientRect(hCell,&rc);                         // there is no text in the memory pointed to by
           FillRect(hDC,&rc,hBrush);                         // pBuffer, i.e., it is null or zero.  In other
           SelectObject(hDC,hTmpBr);                         // words, if you try to change the color of grid
        }                                                    // cells where there is no text, the cell color
        if(pBuffer)                                          // won't change from white to your chosen color
        {                                                    // cuz pBuffer is null.  So you need the FillRect()
           HFONT hTmp=NULL;                                  // call out here - not inside the if(pBuffer)
           COLORREF dwTmpClr=0;
           if(hFont)
              hTmp=(HFONT)SelectObject(hDC,hFont);
           if(dwColor)
              dwTmpClr=SetTextColor(hDC,dwColor);
           /*
           if(hBrush)
           {
              RECT rc;
              HBRUSH hTmpBr=(HBRUSH)SelectObject(hDC,hBrush);
              GetClientRect(hCell,&rc);
              FillRect(hDC,&rc,hBrush);
              SelectObject(hDC,hTmpBr);
           }
           */
           int iBkMode=SetBkMode(hDC,TRANSPARENT);
           TextOut(hDC,1,0,pBuffer,_tcslen(pBuffer));
           if(hFont && hTmp)
              hFont=(HFONT)SelectObject(hDC,hTmp);
           if(dwColor)
              SetTextColor(hDC,dwTmpClr);
           SetBkMode(hDC,iBkMode);
        }
        EndPaint(hCell,&ps);
        #ifdef MYDEBUG
        _ftprintf(fp,_T("Leaving fnCellProc()  --  case WM_PAINT\r\n\r\n"));
        #endif
        return 0;
     }
 }

 return (DefWindowProc(hCell, msg, wParam, lParam));
}
