//=============================================================
//   Developed As An Addition To Matt Pietrek's LibCTiny.lib
//                By Fred Harris, April 2016
//
//   cl fopen.cpp /O1 /Os /GS- /c /W3 /DWIN32_LEAN_AND_MEAN   
//=============================================================
#include <windows.h>
#include "stdio.h"


FILE* fopen(const char* pszFile, const char* pszMode)
{
 DWORD dwDesiredAccess;
 HANDLE hFile=NULL;

 if(*pszMode=='w')
    dwDesiredAccess=GENERIC_WRITE;
 if(*pszMode=='r')
    dwDesiredAccess=GENERIC_READ;
 hFile=CreateFileA(pszFile,dwDesiredAccess,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
 if(hFile==INVALID_HANDLE_VALUE)
    return NULL;

 return (FILE*)hFile;
}


FILE* _wfopen(const wchar_t* pszFile, const wchar_t* pszMode)
{
 DWORD dwDesiredAccess;
 HANDLE hFile=NULL;

 if(*pszMode==L'w')
    dwDesiredAccess=GENERIC_WRITE;
 if(*pszMode==L'r')
    dwDesiredAccess=GENERIC_READ;
 hFile=CreateFileW(pszFile,dwDesiredAccess,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
 if(hFile==INVALID_HANDLE_VALUE)
    return NULL;

 return (FILE*)hFile;
}


int fclose(FILE* fp)
{
 return !CloseHandle((HANDLE)fp);
}
