//=============================================================
//   Developed As An Addition To Matt Pietrek's LibCTiny.lib
//                By Fred Harris, March 2016
//
//  cl fprintf.cpp /O1 /Os /GS- /c /W3 /DWIN32_LEAN_AND_MEAN   
//=============================================================
// cl sprintf.cpp /O1 /Os /GS- /c /W3 /DWIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdarg.h>
#include "stdio.h"
#define EOF (-1)
#pragma comment(linker, "/defaultlib:user32.lib")

int __cdecl fprintf(FILE* fp, const char* format, ...)
{
 char szBuff[1024];
 DWORD cbWritten;
 va_list argptr;
 int retValue;

 va_start(argptr, format);
 retValue = wvsprintfA(szBuff, format, argptr);
 va_end(argptr);
 WriteFile((HANDLE)fp, szBuff, retValue, &cbWritten, 0);

 return retValue;
}

int __cdecl fwprintf(FILE* fp, const wchar_t* pFmtStr, ...)
{
 int retValue,iBytes;
 wchar_t szBuff[512];
 char szABuff[512];
 DWORD cbWritten;
 va_list argptr;
  
 va_start(argptr, pFmtStr);
 retValue = wvsprintfW(szBuff, pFmtStr, argptr);
 va_end(argptr);
 iBytes = WideCharToMultiByte(CP_ACP,0,szBuff,(int)wcslen(szBuff),szABuff,512,NULL,NULL);
 WriteFile((HANDLE)fp, szABuff, iBytes, &cbWritten, 0);

 return retValue;
}


/*
Writes UNICODE

int __cdecl fwprintf(FILE* fp, const wchar_t* format, ...)
{
 wchar_t szBuff[1024];
 DWORD cbWritten;
 va_list argptr;
 int retValue;

 va_start(argptr, format);
 retValue = wvsprintfW(szBuff, format, argptr);
 va_end(argptr);
 WriteFile((HANDLE)fp, szBuff, retValue*2, &cbWritten, 0);

 return retValue;
}
*/

/*
iBytes=WideCharToMultiByte(CP_ACP,0,szBuffW,iChars,szBuffA,1024,NULL,NULL);

int WideCharToMultiByte
(
  UINT CodePage,             // code page
  DWORD dwFlags,             // performance and mapping flags
  LPCWSTR lpWideCharStr,     // address of wide-character string
  int cchWideChar,           // number of characters in string
  LPSTR lpMultiByteStr,      // address of buffer for new string
  int cchMultiByte,          // size of buffer
  LPCSTR lpDefaultChar,      // address of default for unmappable characters
  LPBOOL lpUsedDefaultChar   // address of flag set when default char. used
);
*/